{
THIS UNIT IS PROVIDED "AS IS". IN NO EVENT SHALL I, THE AUTHOR, BE LIABLE
FOR ANY KIND OF LOSS OR, DAMAGE ARISING OUT OF THE USE, ABUSE OR THE INABILITY
TO USE THIS SOFTWARE, NEITHER SHALL CO-AUTHORS AND CONTRIBUTORS. USE IT AT YOUR
OWN RISK!

THIS UNIT COMES WITHOUT ANY KIND OF WARRANTY, EITHER EXPRESSED OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE.

THIS UNIT IS SHAREWARE. NON- EXCLUSIVE PERMISSION TO USE THIS UNIT IN ITS
UNMODIFIED FORM FOR THE SOLE PURPOSE OF BUILDING COMMON GATEWAY INTERFACE "CGI"
APPLICATIONS HEREBY GRANTED.

YOU MAY FURTHER REDISTRIBUTE COPIES OF THIS CGI'S PROVIDED YOU OBTAIN A FEE AND
GIVE 10% OF THE FEE TO KENNETH LEE. YOU ARE NOT ALLOWED TO REDISTRIBUTE MODIFIED
COPIES OF THE UNIT OR MERE PARTS OF IT.

YOU ARE NOT ALLOWED TO SELL THIS UNIT AS A STAND ALONE PRODUCT OR AS PART OF A
SOURCE CODE COMPILATION.

THE SOURCE CODE CONTAINED IN THIS UNIT MAY BE MODIFIED FOR YOUR OWN USE. HOWEVER,
MODIFIED VERSIONS OF THE SOURCE CODE OR BINARIES COMPILED FROM MODIFIED VERSIONS
OF THE SOURCE CODE MUST NOT BE REDISTRIBUTED WITHOUT PRIOR PERMISSION.

IF MODIFICATIONS ARE NECESSARY TO FIX BUGS OR ADD MISSING FUNCTIONALITY FOR THE
NEEDS OF YOUR PARTICULAR APPLICATION.

THE APPROACH IS THAT YOU CONTACT THE AUTHOR (ME) IF YOU FEEL THE CHANGES YOU
MADE TO THE SOURCE CODE SHOULD BE INCORPORATED INTO FUTURE VERSIONS.

IF YOU DON'T AGREE WITH THIS TERMS OR IF YOUR JURISDICTION DOES NOT ALLOW THE
EXCLUSION OF WARRANTY AND LIABILITY AS STATED ABOVE YOU ARE NOT ALLOWED TO USE
THIS SOFTWARE AT ALL.

THIS UNIT IS COPYRIGHT (C)1996-2002 Kenneth Dwayne Lee, ALL RIGHTS RESERVED.

making the common gateway interface common again
Tabboo, the Law by Design

Project Leader/Author contact:
		Kenneth Dwayne Lee
	Pager:	(403) 290-3052
        Web:    http://Diplomatic-Immunity.com
        E-mail:	undeadkennyd@yahoo.ca my paypal account as well.

**Todo List
1. implement for linux
2. build cookie DB componet

}

unit slimjim;

interface

uses
  Windows, SysUtils, Classes, Dialogs, DB;

type

  TMethodType = (cgiGet, cgiPut, cgiPost, cgiHead);
  THtmlValidate = (vdJava, vdBasic, vdNone);

  TIN = class(TPersistent)
  private
    FContent: TStringList;
    FREQUEST_METHOD,
    FSERVER_PROTOCOL,
    FURL,
    FQUERY_STRING,
    FPATH_INFO,
    FPATH_TRANSLATED,
    FHTTP_CACHE_CONTROL,
    FHTTP_DATE,
    FHTTP_ACCEPT,
    FHTTP_FROM,
    FHTTP_HOST,
    FHTTP_IF_MODIFIED_SINCE,
    FHTTP_REFERER,
    FHTTP_USER_AGENT,
    FHTTP_CONTENT_ENCODING,
    FHTTP_CONTENT_TYPE,
    FHTTP_CONTENT_LENGTH,
    FHTTP_CONTENT_VERSION,
    FHTTP_DERIVED_FROM,
    FHTTP_EXPIRES,
    FHTTP_TITLE,
    FREMOTE_ADDR,
    FREMOTE_HOST,
    FSCRIPT_NAME,
    FSERVER_PORT,
    FHTTP_CONNECTION,
    FHTTP_COOKIE,
    FHTTP_AUTHORIZATION: string;
        { Private declarations }
  protected
    { Protected declarations }
  public
     Content:String;
     function GetField(const Name: string): string;
     constructor Create;
     Function ExtHead(Cont: string): TStringList;
     Function ExtContent: TStringList;
     Function ExtQuery: TStringList;
    { Public declarations }
  published
     property CGI_REQUEST_METHOD  :String read FREQUEST_METHOD;
     property CGI_SERVER_PROTOCOL  :String read FSERVER_PROTOCOL;
     property CGI_URL  :String read FURL;
     property CGI_QUERY_STRING  :String read FQUERY_STRING;
     property CGI_PATH_INFO  :String read FPATH_INFO;
     property CGI_PATH_TRANSLATED  :String read FPATH_TRANSLATED;
     property CGI_HTTP_CACHE_CONTROL  :String read FHTTP_CACHE_CONTROL;
     property CGI_HTTP_DATE  :String read FHTTP_DATE;
     property CGI_HTTP_ACCEPT  :String read FHTTP_ACCEPT;
     property CGI_HTTP_FROM  :String read FHTTP_FROM;
     property CGI_HTTP_HOST  :String read FHTTP_HOST;
     property CGI_HTTP_IF_MODIFIED_SINCE  :String read FHTTP_IF_MODIFIED_SINCE;
     property CGI_HTTP_REFERER  :String read FHTTP_REFERER;
     property CGI_HTTP_USER_AGENT  :String read FHTTP_USER_AGENT;
     property CGI_HTTP_CONTENT_ENCODING  :String read FHTTP_CONTENT_ENCODING;
     property CGI_HTTP_CONTENT_TYPE  :String read FHTTP_CONTENT_TYPE;
     property CGI_HTTP_CONTENT_LENGTH  :String read FHTTP_CONTENT_LENGTH;
     property CGI_HTTP_CONTENT_VERSION  :String read FHTTP_CONTENT_VERSION;
     property CGI_HTTP_DERIVED_FROM  :String read FHTTP_DERIVED_FROM;
     property CGI_HTTP_EXPIRES  :String read FHTTP_EXPIRES;
     property CGI_HTTP_TITLE  :String read FHTTP_TITLE;
     property CGI_REMOTE_ADDR  :String read FREMOTE_ADDR;
     property CGI_REMOTE_HOST  :String read FREMOTE_HOST;
     property CGI_SCRIPT_NAME  :String read FSCRIPT_NAME;
     property CGI_SERVER_PORT  :String read FSERVER_PORT;
     property CGI_HTTP_CONNECTION  :String read FHTTP_CONNECTION;
     property CGI_HTTP_COOKIE  :String read FHTTP_COOKIE;
     property CGI_HTTP_AUTHORIZATION  :String read FHTTP_AUTHORIZATION;
    { Published declarations }
  end;

  TOut = class(TPersistent)
    private
      FBody: TStringList;
      FValidation : THtmlValidate;
      FDoc_Name: string;
      procedure SetBody(Value: TStringList);
    public
      constructor Create;
    published
      property Body: TStringList read FBody write SetBody;
      property Name: string read FDoc_Name write FDoc_Name;
      property Validation : THtmlValidate read FValidation write FValidation ;
  end;

  THTMLTagEvent = procedure (Sender: TObject; const TagString: string;
    TagParams: TStringList; var ReplaceText: string) of object;

  TCall= procedure(Sender: TObject; Path: String; Method: TMethodType; Content_In, Content_Out: TStringList) of object;

  TCGI = class(TComponent)
  private
    FIN: TIN;
    FOut: TOut;
    FMethod: TMethodType;
    FOnCall: TCall;
    FOnHTMLTag: THTMLTagEvent;
    { Private declarations }
  protected
     function  GeTHTMLDoc: TOut;
     procedure SeTHTMLDoc(Value: TOut);
     { Protected declarations }
  public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure DoTagEvent(const TagString: string; TagParams: TStringList; var ReplaceText: string);
     function TagParse(Str: String): String;
     procedure init;
    { Public declarations }
  published
     property Method: TMethodType read FMethod write FMethod;
     property _In: TIN read FIN write FIN;
     property _Out: TOut read GeTHTMLDoc write SeTHTMLDoc;
     property OnCall: TCall read FOnCall write FOnCall;
     property OnHTMLTag: THTMLTagEvent read FOnHTMLTag write FOnHTMLTag;
    { Published declarations }
  end;

procedure Register;
function TranslateChar(const Str: string; FromChar, ToChar: Char): string;
function UnixPathToDosPath(const Path: string): string;
function DosPathToUnixPath(const Path: string): string;
function StripHTTP(const Name: string): string;

implementation

function StripHTTP(const Name: string): string;
begin
    if Pos('HTTP_', Name) = 1 then
      Result := Copy(Name, 6, MaxInt)
    else Result := Name;
end;

function TranslateChar(const Str: string; FromChar, ToChar: Char): string;
var
  I: Integer;
begin
  Result := Str;
  for I := 1 to Length(Result) do
    if Result[I] = FromChar then
      Result[I] := ToChar;
end;

function UnixPathToDosPath(const Path: string): string;
begin
  Result := TranslateChar(Path, '/', '\');
end;

function DosPathToUnixPath(const Path: string): string;
begin
  Result := TranslateChar(Path, '\', '/');
end;

procedure Register;
begin
  RegisterComponents('U232', [TCGI]);
end;

constructor TIN.Create;
begin
   FContent:=  TStringList.Create;
    FREQUEST_METHOD:= GetField('REQUEST_METHOD');
    FSERVER_PROTOCOL:= GetField('SERVER_PROTOCOL');
    FURL:= GetField('URL');
    FQUERY_STRING:= GetField('QUERY_STRING');
    FPATH_INFO:= UnixPathToDosPath(GetField('PATH_INFO'));
    FPATH_TRANSLATED:= UnixPathToDosPath(GetField('PATH_TRANSLATED'));
    FHTTP_CACHE_CONTROL:= GetField('HTTP_CACHE_CONTROL');
    FHTTP_DATE:= GetField('HTTP_DATE');
    FHTTP_ACCEPT:= GetField('HTTP_ACCEPT');
    FHTTP_FROM:= GetField('HTTP_FROM');
    FHTTP_HOST:= GetField('HTTP_HOST');
    FHTTP_IF_MODIFIED_SINCE:= GetField('HTTP_IF_MODIFIED_SINCE');
    FHTTP_REFERER:= GetField('HTTP_REFERER');
    FHTTP_USER_AGENT:= GetField('HTTP_USER_AGENT');
    FHTTP_CONTENT_ENCODING:= GetField('HTTP_CONTENT_ENCODING');
    FHTTP_CONTENT_TYPE:= GetField('HTTP_CONTENT_TYPE');
    FHTTP_CONTENT_LENGTH:= GetField('HTTP_CONTENT_LENGTH');
    FHTTP_CONTENT_VERSION:= GetField('HTTP_CONTENT_VERSION');
    FHTTP_DERIVED_FROM:= GetField('HTTP_DERIVED_FROM');
    FHTTP_EXPIRES:= GetField('HTTP_EXPIRES');
    FHTTP_TITLE:= GetField('HTTP_TITLE');
    FREMOTE_ADDR:= GetField('REMOTE_ADDR');
    FREMOTE_HOST:= GetField('REMOTE_HOST');
    FSCRIPT_NAME:= UnixPathToDosPath(GetField('SCRIPT_NAME'));
    FSERVER_PORT:= GetField('SERVER_PORT');
    FHTTP_CONNECTION:= GetField('HTTP_CONNECTION');
    FHTTP_COOKIE:= GetField('HTTP_COOKIE');
    FHTTP_AUTHORIZATION:= GetField('HTTP_AUTHORIZATION');
inherited Create;
end;

Function TIN.ExtHead(Cont: string): TStringList;

         function HTTPDecode(const Str: String): String;
         var
         SPChar, RPChar, CPChar: PChar;
begin
  SetLength(Result, Length(Str));
  SPChar := PChar(Str);
  RPChar := PChar(Result);
  while SPChar^ <> #0 do
  begin
    if not (SPChar^ in ['+','%']) then
      RPChar^ := SPChar^
    else
      if SPChar^ = '+' then
        RPChar^ := ' '
      else
      begin
        inc(SPChar);
        if SPChar^ = '%' then
          RPChar^ := '%'
        else
        begin
          CPChar := SPChar;
          Inc(SPChar);
          RPChar^ := Chr(StrToInt(Format('$%s%s',[CPChar^, SPChar^])));
        end;
      end;
    Inc(RPChar);
    Inc(SPChar);
  end;
  SetLength(Result, RPChar - PChar(Result));
end; //end of HTTPDecode

var
str: string;
idx: integer;
begin
  result := TStringList.Create;
  if (trim(Cont) = '') then Exit;
  repeat
  idx := pos('&',cont)-1;
  str:= copy(cont, 1, idx);
  if str <> '' then result.Append(HTTPDecode(str));
  cont:= copy(cont, idx+2, length(cont)-idx);
  until idx < 0;
  result.Append(HTTPDecode(cont));
end;

Function TIN.ExtContent: TStringList;
begin
  result:= ExtHead(Content);
end;

Function TIN.ExtQuery: TStringList;
begin
  result:= ExtHead(FQUERY_STRING);
end;

function TIN.GetField(const Name: string): string;
var
Variable: string;
Buffer: array[0..4095] of Char;
begin
  SetString(Variable, Buffer, GetEnvironmentVariable(PChar(Name), Buffer, SizeOf(Buffer)));
  if Result = '' then
  SetString(Variable, Buffer, GetEnvironmentVariable(PChar(StripHTTP(Name)), Buffer, SizeOf(Buffer)));
  if (CompareStr(Name, 'HTTP_CONTENT_LENGTH') = 0)
  and (CompareStr(Trim(FREQUEST_METHOD),'POST') = 0) then
  begin
  if IsConsole then
    begin
    Reset(Input);
    FileSeek(TTextRec(INPUT).HANDLE, 0, FILE_BEGIN);
    SetString(Content, nil, TTextRec(INPUT).BufSize);
    FileRead(TTextRec(INPUT).HANDLE, Content[1], TTextRec(INPUT).BufSize);
    Close(Input);
    end;
  end;
  Result:= StrPas(Buffer);
end;

constructor TOut.Create;
begin
  inherited Create;
  FBody:= TStringList.Create;
end;

procedure TOut.SetBody(Value: TStringList);
begin
FBody.Assign(Value);
end;

constructor TCGI.Create(AOwner: TComponent);
var
I, CGICount: Integer;
begin
inherited Create(AOwner);
CGICount:=0;
for I := Owner.ComponentCount - 1 downto 0 do
  begin
    if Owner.Components[I] is TCGI then inc(CGICount);
    if CGICount >= 2 then
    begin
     ShowMessage('Only 1 TCGI per application');
     Owner.RemoveComponent(Owner.Components[Owner.ComponentCount]);
    end;
  end;
FIN:= TIN.Create;
FOut:= TOut.Create;
{if (not (csDesigning in self.ComponentState))
or (not (csDestroying in self.ComponentState))  then }
 if (trim(_Out.Body.Text) = '') then
begin
   _Out.Body.Add ('Content-Type: text/html');
   _Out.Body.Add ('');
   _Out.Body.Add ('<HTML>');
   _Out.Body.Add ('<HEAD>');
   _Out.Body.Add ('<TITLE>Test Page</TITLE>');
   _Out.Body.Add ('</HEAD>');
   _Out.Body.Add ('<BODY>');
   _Out.Body.Add ('<H1><A Href="mailto:undeadkennyd@yahoo.ca">Built using Slimjim.pas</H1>');
   _Out.Body.Add ('<H2>I miss you brittany, maybe your mom and your grand parents will C things my way</H2>');
   _Out.Body.Add ('</BODY>');
   _Out.Body.Add ('Websight developed in part by <A Href="http://diplomatic-immunity.com">Diplomatic-Immunity.com');
   _Out.Body.Add ('</HTML>');
end;

 with _IN do begin
    if CompareText(CGI_REQUEST_METHOD, 'GET') = 0 then
    begin
    FMethod := cgiGet;
    FContent.Assign(ExtQuery);
    end
  else if CompareText(CGI_REQUEST_METHOD, 'PUT') = 0 then
    FMethod := cgiPut
  else if CompareText(CGI_REQUEST_METHOD, 'POST') = 0 then
    begin
    FMethod := cgiPost;
    FContent.Assign(ExtContent);
    end
  else if CompareText(CGI_REQUEST_METHOD, 'HEAD') = 0 then
    FMethod := cgiHead;
  end;
end;

destructor TCGI.Destroy;
begin
if IsConsole then Write(_Out.Body.Text);
_Out.Free;
_IN.Free;
inherited Destroy;
end;

function TCGI.GetHTMLDoc: TOut;
begin
  if FOut = nil then FOut := TOut.Create;
  Result := FOut;
end;

procedure TCGI.SetHTMLDoc(Value: TOut);
begin
  if Value = nil then
  begin
    FOut.Free;
    FOut := nil;
    Exit;
  end;
  FOut.Assign(Value);
end;

procedure TCGI.init;
var
i: integer;
begin
if Assigned(FOnCall) then FOnCall(Self, _IN.CGI_PATH_INFO, self.Method, _In.FContent, _Out.Body);
if (_Out.Body.Count >= 0) then
begin
for i := 0 to _Out.Body.Count -1 do
   if Trim(_Out.Body.Strings[i]) <> '' then
   _Out.Body.Strings[i] := TagParse(_Out.Body.Strings[i]);
end;
end;

procedure TCGI.DoTagEvent(const TagString: string;
  TagParams: TStringList; var ReplaceText: string);
begin
  if Assigned(FOnHTMLTag) then
    FOnHTMLTag(Self, TagString, TagParams, ReplaceText);
end;

function TCGI.TagParse(Str: String): String;
var
idx, I: integer;
tmp, TagStr, RepStr: String;
TagPara: TStringList;
begin
tmp:= '';
idx:= 0;
 repeat
 if (Str[idx] = '<') and (Str[idx+1] = '!') and (Str[idx+2] = '-') and (Str[idx+3] = '-') then
  begin
  TagStr:= '';
  inc(idx,4);
  repeat
  TagStr:= TagStr + Str[idx];
  inc(idx);
  until (Str[idx] = '-') and (Str[idx+1] = '-') and (Str[idx+2] = '>');
  inc(idx,2);
  TagPara:= TStringList.Create;
  TagPara.CommaText := TagStr;
  TagStr:= TagPara.Strings[0];
  TagPara.Delete(0);
  with Owner do
       for I := 0 to ComponentCount - 1 do
           if Components[i].InheritsFrom(TField) and (Components[i].Name = TagStr)
           then RepStr := TField(Components[i]).AsString;
  DoTagEvent(TagStr, TagPara, RepStr);
  tmp:= tmp + RepStr;
  TagPara.free;
  end else if Str[idx] <> #0 then tmp:= tmp + Str[idx];
 inc(idx);
 until idx >= length(Str)+1;
result:= tmp;
end;

end.
